VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "C_Individu"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False

Option Explicit

Public EstJoueur As Boolean
Public Nom As String
Public Index, IndexImage As Long
Public X, Y As Integer
Public X_Precedent, Y_Precedent As Integer
Public cPersonnage As C_Personnage


Public Function DessinerImage() As Long
    Dim nbImages As Long
    nbImages = cVariables.frmPrincipale.ImgPersonnage.Count
    Load cVariables.frmPrincipale.ImgPersonnage(nbImages)
    With cVariables.frmPrincipale.ImgPersonnage(nbImages)
        Set .Container = cVariables.pMatrice
        .Left = cVariables.Pas * (X)
        .Top = cVariables.Pas * (Y)
        .Height = cVariables.Pas
        .Width = cVariables.Pas
        Set .Picture = Me.cPersonnage.varImage
        .Visible = True
        .ZOrder 0
    End With
    Me.IndexImage = nbImages
    DessinerImage = nbImages
End Function


Public Function Deplacer(Direction As ORIENTATIONS, Optional ByVal booRafraichirScrolling As Boolean) As Boolean
    Dim cCase As C_Case
    Dim X_Destination, Y_Destination As Integer
    X_Destination = cFonctions.X_SelonDirection(Direction) + X
    Y_Destination = cFonctions.Y_SelonDirection(Direction) + Y
    ' On teste la case de destination :
    If cFonctions.TesterCaseFranchissable(X_Destination, Y_Destination) = False Then
        ' Trouver une direction alternative
        Direction = cFonctions.DirectionAlternative(X, Y, Direction)
        If Direction = IMMOBILE Then Exit Function      ' le dplacement ne peut avoir lieu
    End If
    ' Le dplacemnet pourra avoir lieu, on actualise les variables
    X_Destination = cFonctions.X_SelonDirection(Direction) + X
    Y_Destination = cFonctions.Y_SelonDirection(Direction) + Y
    X_Precedent = X
    Y_Precedent = Y
    Me.X = X_Destination
    Me.Y = Y_Destination
    
    ' Le dplacement a lieu, on marque la case de destination
    Set cCase = cMatrice.CaseSelonCoordonnees(X_Destination, Y_Destination)
    cCase.ExisteIndividu = True
    cCase.indexIndividu = Me.Index
    ' Si joueur, on rafraichit d'abord le scrolling (le faire avant le dplacement du personnage vite des sautes d'images)
    cVariables.frmPrincipale.ImgPersonnage(IndexImage).Move cVariables.Pas * X_Destination, cVariables.Pas * Y_Destination

    If booRafraichirScrolling = True Then
        Call cFonctions.Scrolling
        Call cVision.RafraichirChamp(X_Destination, Y_Destination)
    End If
    
    ' On libre la case d'origine :
    Set cCase = cMatrice.CaseSelonCoordonnees(X_Precedent, Y_Precedent) ' Ancienne position
    cCase.ExisteIndividu = False
    cCase.indexIndividu = 0

    Deplacer = True
End Function


Public Function DeplacementErratique()
    Call Me.Deplacer(cFonctions.NombreAleatoire(0, 8))
End Function

