Attribute VB_Name = "M_Constantes"

Public LeMOT As String ' tous les jets alatoires sont fait selon "le mot"
Public UtiliserMot As Boolean
Public IncrementMot As Double

Public cDatabase As New C_Database
Public cMatrice As New C_Matrice
Public cCartographe As New C_Cartographe
Public cVariables As New C_Variables
Public cFonctions As New C_Fonctions
Public cElement As New C_Element
Public cFonds() As New C_Fond
Public cDecors() As New C_Decors
Public cPersonnages() As New C_Personnage
Public cIndividus() As New C_Individu
Public cLigne As New C_Ligne
Public cVision As New C_Vision
Public cJoueur As New C_Individu

Public ModeDev As Boolean

Public Const NB_PLANS = 4
Public Enum Plans
    ' Element FOND (arrire plan)
    ' Exemple : Sol, Mur, Vide
    FOND = 0
    ' Element DECORS (plan loign)
    ' Exemple : Porte, Tapisserie, Pige
    DecorS = 1
    ' Element USTENSILES (plan moyen)
    ' Exemple : Fusil, Gourde, Coffret
    USTENSILE = 2
    ' Element PERSONNAGES (plan rapproch)
    ' Exemple : Personnage joueur, Monstre, Alli
    PERSONNAGE = 3
    ' Eventuellement "Avant plan"
End Enum

Public Const NB_ORIENTATIONS = 4
Public Enum ORIENTATIONS
    NORD = 0
    EST = 1
    SUD = 2
    OUEST = 3
    NORD_EST = 4
    SUD_EST = 5
    SUD_OUEST = 6
    NORD_OUEST = 7
    IMMOBILE = 8
End Enum

Public Type Coord
    X As Integer
    Y As Integer
End Type

Public Type Segment
    Depart As Coord
    Arrivee As Coord
    Paroi As ORIENTATIONS
    Sens As Integer
End Type

' TABLEAUX DES MODULES DE CLASSE
' Cette petite bouse de VB ne pouvant passer un tableau en param ou le renvoyer depuis un module de classe,
' on transite pour se faire par des Variables globales utilises ponctuellement
' Note : pour que cela fonctionne, ces tableaux transitoires ne doivent jamais tre dimensionns.

Public Type Tableaux_Globaux
    Contour() As Segment
    cCases() As New C_Case
End Type
Public gTab As Tableaux_Globaux


