VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "C_Case"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit


Public cMatrice As C_Matrice ' Pointeur vers la classe mre pour ventuellement appeler ses fonctions (simule l'hritage)
Public Index As Integer ' Retient l'Id unique de la case (autrement que par ses coordonnes)
Public IdBase As Integer
Public X As Integer ' Retient les coordonnes de la case
Public Y As Integer

Public EstUneIssue As Boolean
Public IndexIssue As Integer ' Index de l'issue dans le tableau du cartographe
Public EstUnLieu As Boolean
Public IndexLieu As Integer ' Index du lieu dans le tableau du cartographe
Public EstUnContour, EstUneJonction As Boolean
Public NbLieuxContour As Integer 'nombre de lieu utilisant le contour (de 0  4)
Public IndexImage As Integer ' Retient l'index du control image correspondant  la case MAUVAIS A ABANDONNE !
Public EstFranchissable As Boolean

Public EstAllumee, EstSurlignee, EstVisitee, DoitEtreEteinte As Boolean

' Instancis uniquement si existent
Public cFond As C_Fond
Public cDecor As C_Decors

Public ExisteFond, ExisteDecor, ExisteIndividu As Boolean
Public IndexImageFond, IndexImageDecor As Long
Public IndexIndividu As Long


Public Function InfosDebug() As String
    Dim s As String
    s = s & "CASE -  X, Y : " & X & ", " & Y & "     " & vbCrLf
    s = s & "EstUneIssue : " & EstUneIssue & "     " & "IndexIssue : " & IndexIssue & "     " & "EstUnLieu : " & EstUnLieu & "     " & "IndexLieu : " & IndexLieu & vbCrLf
    s = s & "EstUnContour : " & EstUnContour & "   " & "EstUneJonction : " & EstUneJonction & "   " & vbCrLf
    s = s & "ExisteFond : " & ExisteFond & "   " & "ExisteDecor : " & ExisteDecor & "   " & vbCrLf
    InfosDebug = s & vbCrLf
End Function


Public Sub Initialiser(cMatrice As C_Matrice)
    ' On charge les diffrents plans de la case
    Dim i As Integer

    Set Me.cMatrice = cMatrice

End Sub


Public Sub DessinerCase()
    If Me.ExisteDecor Then Me.IndexImageDecor = Me.DessinerImage(Me.cDecor.varImage)
    If Me.ExisteFond Then Me.IndexImageFond = Me.DessinerImage(Me.cFond.varImage)
End Sub

' A_FAIRE : une image pour le fond, une pour le decors, etc.. vite de dpasser la limite d'index (integer)
Public Function DessinerImage(varImage As Variant) As Long
    ' A_FAIRE :  l'avenir, comme on effacera les images, il risquera d'y avoir des "trous"
    ' aussi, il faudra identifier l'index d'image cr qui ne sera sans doute pas gal au nbImages
    Dim nbImages As Long
    nbImages = cVariables.frmPrincipale.ImgTile.Count
   ' cVariables.pMatrice
    Load cVariables.frmPrincipale.ImgTile(nbImages)
    With cVariables.frmPrincipale.ImgTile(nbImages)
        .Left = cVariables.Pas * (X)
        .Top = cVariables.Pas * (Y)
        .Height = cVariables.Pas
        .Width = cVariables.Pas
        Set .Picture = varImage
        .ZOrder 1
        If ModeDev = True Then .Visible = True ' A_FAIRE : attention au pige
    End With
    
   ' Me.EstAllumee = False ' A_FAIRE : attention au pige
    Me.IndexImage = nbImages
    DessinerImage = nbImages
End Function


Public Function AllumerImageFond()
    If IsEmpty(Me.IndexImageFond) Then Exit Function
   ' If Me.EstAllumee = True Then Exit Function
    If Me.EstVisitee = False Then cVariables.frmPrincipale.ImgTile(Me.IndexImageFond).Visible = True
    Me.EstVisitee = True
    Set cVariables.frmPrincipale.ImgTile(Me.IndexImageFond).Picture = Me.cFond.varImageA
End Function


Public Function EteindreImageFond()
    If IsEmpty(Me.IndexImageFond) Then Exit Function
   ' If Me.EstAllumee = False Then Exit Function
    Set cVariables.frmPrincipale.ImgTile(Me.IndexImageFond).Picture = Me.cFond.varImage
End Function


Public Function SetEstFranchissable()
    Me.EstFranchissable = False
    If Me.ExisteFond = False Then Exit Function
    If Me.ExisteDecor = False And Me.cFond.EstFranchissable = False Then Exit Function
    If Me.ExisteDecor = True Then
        If Me.cDecor.EstFranchissable = False Then Exit Function
    End If
    Me.EstFranchissable = True
End Function



