VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "C_Fonctions"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False

Option Explicit


Function ConnectionOuvrir(dbConn As ADODB.Connection)
    Dim strCheminBase As String
    strCheminBase = App.Path & "\Base\Arche.mdb"
    Set cVariables.dbConn = New ADODB.Connection
    cVariables.dbConn.ConnectionString = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" & strCheminBase
    cVariables.dbConn.Open
End Function


Function ConnectionFermer(dbConn As ADODB.Connection)
    cVariables.dbConn.Close
    Set cVariables.dbConn = Nothing
End Function


Public Function CompterEnregistrements(rs As ADODB.Recordset) As Long
    CompterEnregistrements = 0
    If Not rs.EOF Then
        rs.MoveLast
        rs.MoveFirst
        CompterEnregistrements = rs.RecordCount
    End If
End Function


Public Function EnregistrementMax(ByVal strNomTable As String, ByVal strNomChamp As String) As Variant
    Dim sql As String
    Dim rs As New ADODB.Recordset
    sql = "SELECT TOP 1 (" & strNomChamp & ") AS MaxChamp FROM " & strNomTable & " GROUP BY " & strNomChamp & " ORDER BY " & strNomChamp & " DESC"
    rs.Open sql, cVariables.dbConn, adOpenDynamic
    EnregistrementMax = rs(0)
    rs.Close
    Set rs = Nothing
End Function


Public Function NombreAleatoire(ByVal intMinimum As Integer, ByVal intMaximum As Integer) As Integer
   ' Dim intEcartRnd, intMinima As Integer
    ' intEcartRnd = Abs(intMaximum - intMinimum) + 1
    ' intMinima = intMinimum
    ' If intMinimum > intMaximum Then intMinima = intMaximum
    If UtiliserMot = True Then
        ' IncrementMot = IncrementMot + 0.1
        ' Randomize LeMOT ' * (IncrementMot)
    Else
        Randomize
    End If
    NombreAleatoire = Int((intMaximum - intMinimum + 1) * Rnd) + intMinimum
    ' NombreAleatoire = Int(intEcartRnd * Rnd) + intMinima
End Function


Function AsciiDeMot(ByVal strMot As String) As Double
  '  cdbl()
    Dim i As Integer
    Dim str As String
    For i = 0 To Len(strMot) - 1
        str = str & CStr(Asc(Mid(strMot, (i + 1), 1)))
    Next
    AsciiDeMot = CDbl(str)
End Function


Public Function ChargerImage(ByVal strDossierImage As String, ByVal strNomImage As String) As Variant
    Dim strChemin As String
    strChemin = App.Path & "\Images\" & strDossierImage & "\" & strNomImage
    Set ChargerImage = LoadPicture(strChemin)
End Function


Public Function X_SelonDirection(ByVal Direction As ORIENTATIONS)
    Select Case Direction
        Case NORD, SUD
            X_SelonDirection = 0
        Case EST, NORD_EST, SUD_EST
            X_SelonDirection = 1
        Case OUEST, NORD_OUEST, SUD_OUEST
            X_SelonDirection = -1
    End Select
End Function


Public Function Y_SelonDirection(ByVal Direction As ORIENTATIONS)
    Select Case Direction
        Case EST, OUEST
            Y_SelonDirection = 0
        Case SUD, SUD_EST, SUD_OUEST
            Y_SelonDirection = 1
        Case NORD, NORD_EST, NORD_OUEST
            Y_SelonDirection = -1
    End Select
End Function


Public Function TrouverDirection(ByVal Xo As Integer, ByVal Yo As Integer, ByVal Xd As Integer, ByVal Yd As Integer) As ORIENTATIONS
    ' Principe : la valeur qui se rapproche le plus d'un delta indique la direction
   ' Dim dX, dY As Integer ' diffrence en valeur absolue
   ' Dim dD As Integer ' Diagonale parfaite sur un carr en prenant le plus haut score entre dX et dY
   ' Dim dMax As Integer
   ' Dim Diagonale As Integer
   ' Dim Xs, Ys As Integer ' diffrence avec signe
   ' Xs = Xd - Xo
  '  Ys = Yd - Yo
  '  dX = Abs(Xs)
  '  dY = Abs(Ys)
  '  dMax = dX
    ' If dY > dX Then dMax = dY
    ' Diagonale = CInt(Sqr(dX * dX + dY * dY) - 0.5)
    ' dD = CInt(Sqr(dMax * dMax + dMax * dMax) - 0.5)
    
    ' cas les plus simples :
   ' If dX = Diagonale Or dY = Diagonale Or dD = Diagonale Or Diagonale = 0 Then
   '     TrouverDirection = DirectionSelonXY(Xs, Ys) ' dplacement horizontal
    '    Exit Function
   ' End If
    
    ' Autres cas, de quoi se rapproche le plus la Diagonale ?
    ' on pourrait faire des tris et comparaison, mais avec une ligne de brensenham, ca colle :
    If Xo = Xd And Yo = Yd Then
        TrouverDirection = IMMOBILE
        Exit Function
    End If
    
    Dim cLigne As New C_Ligne
    Dim cCase As New C_Case
    cLigne.PrepareLigne Xo, Yo, Xd, Yd, True
    Set cCase = cLigne.GetCaseSelonIndex(0)
    TrouverDirection = DirectionSelonXY(cCase.X - Xo, cCase.Y - Yo)
End Function


Public Function DirectionSelonXY(ByVal Xs As Integer, ByVal Ys As Integer) As ORIENTATIONS
    If Ys = 0 And Xs = 0 Then DirectionSelonXY = IMMOBILE
    If Ys > 0 And Xs = 0 Then DirectionSelonXY = SUD
    If Ys = 0 And Xs < 0 Then DirectionSelonXY = OUEST
    If Ys < 0 And Xs = 0 Then DirectionSelonXY = NORD
    If Ys = 0 And Xs > 0 Then DirectionSelonXY = EST
    If Ys > 0 And Xs > 0 Then DirectionSelonXY = SUD_EST
    If Ys > 0 And Xs < 0 Then DirectionSelonXY = SUD_OUEST
    If Ys < 0 And Xs < 0 Then DirectionSelonXY = NORD_OUEST
    If Ys < 0 And Xs > 0 Then DirectionSelonXY = NORD_EST
End Function


Public Function Scrolling()
    ' Centre la matrice autour du personnage
    Dim X_Centre, Y_Centre As Integer
    X_Centre = CInt(cVariables.pConteneur.Width / 2 - 0.5)
    Y_Centre = CInt(cVariables.pConteneur.Height / 2 - 0.5)
    cVariables.pMatrice.Left = X_Centre - cJoueur.X * cVariables.Pas
    cVariables.pMatrice.Top = Y_Centre - cJoueur.Y * cVariables.Pas
End Function


Public Function TesterCaseFranchissable(ByVal X As Integer, ByVal Y As Integer) As Boolean
    Dim cCase As C_Case
    Set cCase = cMatrice.CaseSelonCoordonnees(X, Y)
    TesterCaseFranchissable = cCase.EstFranchissable
End Function

Public Function DirectionAlternative(ByVal X As Integer, ByVal Y As Integer, Direction As ORIENTATIONS) As ORIENTATIONS
    ' La direction doit tre trouve en fctn de la ligne Brensenham et le clic d'origine en fait
    Dim DirectionA, DirectionB As ORIENTATIONS
    ' mais on va se contenter d'abord de ceci :
    DirectionAlternative = IMMOBILE
    ' Direction alternative seulement en cas de dplacement en diagonale
    Select Case Direction
        Case NORD_EST
            DirectionA = EST
            DirectionB = NORD
        Case SUD_EST
            DirectionA = EST
            DirectionB = SUD
        Case SUD_OUEST
            DirectionA = OUEST
            DirectionB = SUD
        Case NORD_OUEST
            DirectionA = OUEST
            DirectionB = NORD
        Case Else
            Exit Function
    End Select
    If TesterCaseFranchissable(X + X_SelonDirection(DirectionA), Y + Y_SelonDirection(DirectionA)) Then
        DirectionAlternative = DirectionA
        Exit Function
    End If
    If TesterCaseFranchissable(X + X_SelonDirection(DirectionB), Y + Y_SelonDirection(DirectionB)) Then
        DirectionAlternative = DirectionB
        Exit Function
    End If
End Function
