VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "C_Vision"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False

Option Explicit

' Prcalcule un champ de vision, de sorte qu'il ne soit pas calcul  chaque dplacement.

Dim cLignes() As New C_Ligne
Dim nbLignes As Integer
Dim Rayon As Integer ' pour l'instant, champ carr
Dim cCoord() As Coord ' En relatif
Dim NbCoords As Integer
Public X_Precedent, Y_Precedent As Integer


Public Function CreerVision()
 
    Call CreerPerimetre
    Call CreerChamp
    ' Call AllumerChamp(X_Absolu, Y_Absolu)
End Function

Public Function CreerPerimetre()
    Dim i, IndexCoord As Integer
    Rayon = 3
    NbCoords = (Rayon * 2 + 1) * 2 + (Rayon * 2 - 1) * 2
    ReDim cCoord(NbCoords)
    ' 0,0 est la position centrale
    For i = -Rayon To Rayon ' segments nord et sud
        cCoord(IndexCoord).X = i
        cCoord(IndexCoord).Y = Rayon
        IndexCoord = IndexCoord + 1
        cCoord(IndexCoord).X = i
        cCoord(IndexCoord).Y = -Rayon
        IndexCoord = IndexCoord + 1
    Next
    For i = (-Rayon + 1) To (Rayon - 1) ' segments ouest et est
        cCoord(IndexCoord).X = Rayon
        cCoord(IndexCoord).Y = i
        IndexCoord = IndexCoord + 1
        cCoord(IndexCoord).X = -Rayon
        cCoord(IndexCoord).Y = i
        IndexCoord = IndexCoord + 1
    Next
    NbCoords = IndexCoord
End Function

Public Function CreerChamp()
    Dim i As Integer
    ' Joint une ligne du centre  chaque case du primtre
    nbLignes = NbCoords * 2
    ReDim cLignes(nbLignes)
    For i = 0 To (nbLignes / 2) - 1
        cLignes(i).PrepareLigne 0, 0, cCoord(i).X, cCoord(i).Y
    Next
    For i = (nbLignes / 2) To nbLignes
        cLignes(i).PrepareLigne cCoord(i - nbLignes / 2).X, cCoord(i - nbLignes / 2).Y, 0, 0
    Next
End Function


Public Function AllumerChamp(ByVal X_Absolu As Integer, ByVal Y_Absolu As Integer)
    Dim i As Integer
    X_Precedent = X_Absolu
    Y_Precedent = Y_Absolu
    For i = 0 To (nbLignes / 2) - 1
        Call cLignes(i).AfficheLigneVision(X_Absolu, Y_Absolu)
    Next
    For i = (nbLignes / 2) To nbLignes
        Call cLignes(i).AfficheLigneVision(X_Absolu, Y_Absolu, True)
    Next
End Function


Public Function EteindreChamp()
    Dim i As Integer
    For i = 0 To nbLignes
        Call cLignes(i).EffaceLigneVision(X_Precedent, Y_Precedent)
    Next
End Function


Public Function RafraichirChamp(ByVal X_Absolu As Integer, ByVal Y_Absolu As Integer)
    ' Allume les nouvelles cases, efface seulement celles n'ayant plus cours
    Dim i, X_Old, Y_Old As Integer
    X_Old = X_Precedent
    Y_Old = Y_Precedent
    ' On marque doit etre eteinte pour les anciennes cases
    For i = 0 To nbLignes
        Call cLignes(i).MarqueLigneDoitEtreEteinte(X_Old, Y_Old)
    Next
    
    ' Allume les nouvelles cases et les marque ne doit pas etre eteintes
    Call AllumerChamp(X_Absolu, Y_Absolu)
    
    ' Eteint les cases avec "doit etre eteinte"
    For i = 0 To nbLignes
        Call cLignes(i).EffaceLigneVisionPrecedente(X_Old, Y_Old)
    Next

End Function
